static char *cvs_id =" $Id: dmi_lib.c,v 1.1.1.1 2002/01/03 14:52:03 berar Exp $ ";
/*  dmi_lib : files from DMI card (IPN-Orsay)  */
/*  jf berar */


#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
/*-----------------------------------------------------------*/
#include "dmi_def.h"
/*-----------------------------------------------------------*/
/* le label de sauvegarde normalise IPN MAI-88 precede les canaux
   pour les bidim les monodim X se suivent                       */
typedef struct
{
    char RUN[16];    
    char NUMR[8];
    char NOM[16];
    char NUMS[8];
    char DATE[20];   /* JJ-MMM-YY  HH:MM:SS                */
    char TYPE[12];   /* 1D, 2D ou 3D            80cars --> */
    char CODE[8];    /* BIT*1, BIT*8, INT,REAL...          */
    char NCX[8];
    char DX[8];
    char NCY[8];
    char DY[8];
    char NCZ[8];
    char DZ[8];
    char NCT[8];
    char DT[8]; 
    char SWAP[4];    /*  MSB ou LSB  */
    char RES1[4];    /*  nb fois 256 pour label  80cars --> */  
    char COMMENT[80];
    char IPAPLIC[8];
    char HLONG[8];    /*  lg tot du header en octets  256cars --> */
    char APPLIC[16];  /* source IBMPC / application VDMI-3.00     */
    char VERLAB[8];   /* version du label                         */
    char NBMQ[8];     /*  nb marqueurs   */
    char AX[16];      /* calibration en X, Y   */
    char BX[16];
    char UX[8];
    char AY[16];
    char BY[16];
    char UY[8];
    char LIBRE[8];
    char MQ[16][7];
    char FIN[16+8];    /*  attention erreur sur lg necessaire 512 --> */
    }    IPN_HDR;
#define DMI_HDR_LG  512L
/*-----------------------------------------------------------*/
XY_HDR   *dmi_gethdr (FILE *f);    
void      dmi_hdrfill (FILE *f, XY_HDR *h, char * fname);    
/*-----------------------------------------------------------*/
static IPN_HDR ipn_hdr;
/* read dmi file header                                  */
/*-----------------------------------------------------------*/
XY_HDR *dmi_gethdr( FILE *f)       /* quick open, just get image size */
{   INT16U  val;
    SWAP16  swaptest;
    XY_HDR  *h;

    fseek( f, 0, 0);
    fread( &ipn_hdr, sizeof(IPN_HDR), 1, f);
    swaptest.brut = 0x7fff;
    if (ipn_hdr.SWAP[1] == 'M' ) 
    {   if ( swaptest.c.h < 0 ) xy_setswapon();
        else xy_setswapoff();
        }
    else if (ipn_hdr.SWAP[1] == 'L' )
    {   if ( swaptest.c.h < 0 ) xy_setswapoff();
        else xy_setswapon();
        }
    else v_error(__FILE__, "unknown ByteOrder %4c\n", ipn_hdr.CODE);

    h = (XY_HDR *) malloc(sizeof(XY_HDR));
    memset(h, 0, sizeof(XY_HDR));
    h->x_dim=atoi(ipn_hdr.NCX);
    h->y_dim=atoi(ipn_hdr.NCY);
    if ( strstr( ipn_hdr.CODE, "BIT*16") ) h->t_data = T_INT16U; 
       else h->t_data = INVALID_DATA;
    h->frames=1;
    h->header_end = DMI_HDR_LG;
    return h;    
    }
/*-----------------------------------------------------------*/
#define BUF_LG 127
void dmi_hdrfill( FILE *f, XY_HDR *h, char * fname)
{   char *c, buffer[BUF_LG+1];

    h->edf_disp = h->edf_used = 0;
    xy_edfstr( h, "HeaderID", "EH:000001:000000:000000");
    xy_edfstr( h, "ByteOrder", "LowByteFirst");
    sprintf(buffer,"%hd", h->x_dim);
    xy_edfstr(h, "Dim_1", buffer);
    sprintf(buffer,"%hd", h->y_dim);
    xy_edfstr(h, "Dim_2", buffer);
    sprintf(buffer,"%d", h->frames);
    xy_edfstr(h, "Image", buffer);
   
    strncpy(buffer, ipn_hdr.DATE, 20);
    xy_edfstr(h, "Experiment_date", buffer );
    strncpy(buffer, ipn_hdr.NOM, 4);
    xy_edfstr(h, "Ipn_Map", buffer );
    strncpy(buffer, ipn_hdr.RUN, 20);
    xy_edfstr(h, "Ipn_Run", buffer );
    xy_edfstr(h, "Ipn_File", fname );
    sprintf(buffer, "%s based on IPN LABEL 1988, %s\n", __FILE__, __DATE__);
    c = strrchr( buffer, '\n');
    if ( c ) *c=0;
    c = strrchr( buffer, '\r');
    if ( c ) *c=0;
    xy_edfstr(h, "Software", buffer);
    if (h->t_data != T_INT16U )
    {    xy_fputhdr(stderr, h, 1);
         V_ERROR(" not supported data type!\n");
         }
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
XY_HDR  *dmi_open (char * name, char *msg, int quick)
{   FILE   *f;
    XY_HDR *h;
    char   *n, buffer[200];
    strcpy (buffer, name);
    f = fopen( buffer, "rb");
    if ( f == NULL ) v_error( __FILE__, "dmi_open : unable to open %s file '%s'\n", msg, buffer);
    h = dmi_gethdr( f ); 
    if (h->t_data != T_INT16U || quick == 0 )
    {    dmi_hdrfill(f , h, buffer);
         }
    else h = dmi_gethdr( f );
    n = (char * ) malloc( 1+strlen(buffer));
    strcpy (n, buffer);
    h->name = n;
    h->file = f;
    return h;
    }
/*-----------------------------------------------------------*/
/* lit le fichier de dark et effectue les moyennes */
INT16U  *dmi_getdark( XY_HDR *h, IMAGE *img, int first, int last, float z_cosmic, float t_cosmic )
{   INT32    *res;
    INT16U   *dark;
    int      l, n;
    long     i;

    if (img->size == 0) xy_setsize( img );
    dark = (INT16U  *) malloc( img->tsize * sizeof(INT16U));
    if (dark==NULL) v_error("dmi_lib", "dark : allocating memory %d\n", img->tsize * sizeof(INT16U));
    res =  (INT32  *) malloc( img->tsize * sizeof(INT32));
    if (res==NULL) V_ERROR("allocating memory : res");
    memset(res, 0, img->size * sizeof(INT32));

    l = n = 0;
    do
    {    if ( ++l < first ) continue;
         if ( last != 0 && l > last) break;
         if ( dmi_getraw( h, img, dark, l) <= 0 ) continue;
         n++;
         for (i=0; i<img->size; i++) res[i] += dark[i];
         } while ( !feof( h->file) );

    if ( n == 0 )
       v_error( __FILE__,  "no data found in dark file between image %d and %d\n", first, last);
    img->used_frames = n;
    for (i=0; i<img->size; i++) dark[i] = (res[i] + n/2)/n;
/*    h->info.mini = xy16u_min(img, dark);   /* no binding here */
/*    h->info.maxi = xy16u_max(img, dark);   
    h->info.mean = xy16u_mean(img, dark);   
    h->info.sigma = xy16u_sigma(img, dark, h->info.mean);
*/    free(res);
    return dark;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/* recupere une image depuis la position courante du fichier */
int dmi_getraw(XY_HDR *h, IMAGE *img, INT16U *val, int pos)
{   int  i, j, k, xread, xseek, xfor, yfor;
    long   y, p, po;
    INT16U   *v;
    INT16U   *raw;

    p = po = DMI_HDR_LG + sizeof(INT16U) * ( (pos-1) * img->osize 
           + img->y_omin * img->x_osize + img->x_omin );
   xread=sizeof(INT16U)*img->x_tsize;
   xseek=sizeof(INT16U)*img->x_osize;
   xfor=img->x_tsize;
   yfor=img->y_tsize;
   for ( k=0, v=val; k<yfor; k++, v+=xfor, p+=xseek )
   {   fseek( h->file, p, 0);
       if ( (j=fread( v, xread, 1, h->file)) != 1 )
       if ( k == 0 )  return 0;
       else
       {   fprintf(stderr, "error %d reading %d image at y = %d, y_min %d, pos %d\n",
                  errno, j, k+img->y_omin, img->y_omin, pos);
           return -1;
           }
       if (xy_doswap) for (i=0; i < xfor; i++) xy_eswap16 (v+i);
       }   
   return img->y_tsize;    
   }
/*-----------------------------------------------------------*/
int dmi_getimg(XY_HDR *h, IMAGE *img, int pos)
{   INT32 *val;
    INT16U *raw;
    int i;
    raw = (INT16U *) malloc(img->osize * sizeof(INT16U));
    i = dmi_getraw(h, img, raw, pos);
    val= xy16u_bind( img, raw);
    free(raw);
    img->name = h->name;
    return i;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/

