static char *cvs_id =" $Id: gel_lib.c,v 1.1.1.1 2002/01/03 14:52:03 berar Exp $ ";
/*  gel_lib : image plates au format tiff */
/*  jf berar */


#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
/*-----------------------------------------------------------*/
#include "gel_def.h"
/*-----------------------------------------------------------*/
#define GEL_HDR_LG  560L
XY_HDR   *gel_gethdr (FILE *f);    
void    gel_getfill (FILE *f, XY_HDR *h);    
/*-----------------------------------------------------------*/
char *ifd_tag_name( INT16U tag);
void print_ifd ( int i, int n, TIF_IFD *ifd, char * b );
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/* read gel file header                                      */
XY_HDR *gel_gethdr( FILE *f )
{   int i;
    INT16U  val;
    XY_HDR  *h;
    INT16U tag_used, stripoffset, bitspersample;
    INT32  offset;
    long ifd_offset;
    TIF_IFD ifd;

    fread( &val, sizeof(INT16U), 1, f);
    if ( val != 0x4949 && val != 0x4d4d )
        V_ERROR(" invalid gel file ID nor 'MM' neither 'II'\n");
    fread( &val, sizeof(INT16U), 1, f);
    if ( val == 0x2a00 ) xy_setswapon();
    else if ( val == 0x002a )  xy_setswapoff();
    else  V_ERROR(" invalid gel file key not 0x2a\n");

    h = (XY_HDR *) malloc(sizeof(XY_HDR));
    xy_fread32( &offset,  0x04L, f);
    xy_fread16( &tag_used,    offset, f);
    if (tag_used == 0 ) V_ERROR(" no tags found in the file");
    if (tag_used > 100) V_ERROR(" more than 100 tags found in the file");
    ifd_offset = 2 + offset;
    for (i = 0; i < tag_used; i++)
    {   xy_fread16( &ifd.tag.u, ifd_offset + i * sizeof(TIF_IFD), f);
        xy_fread16( &ifd.typ.u, ifd_offset + 2 + i * sizeof(TIF_IFD), f);
        xy_fread32( &ifd.cnt.l, ifd_offset + 4 + i * sizeof(TIF_IFD), f);
        switch ( ifd.tag.u)
        {  case 0x100 :  switch (ifd.typ.u)
           {  case 3 : xy_fread16( &ifd.val.u[0], ifd_offset + 8 + i * sizeof(TIF_IFD), f);
                    h->x_dim = ifd.val.u[0];
                    break;
              case 4 : xy_fread32( &ifd.val.l, ifd_offset + 8 + i * sizeof(TIF_IFD), f);
                    h->x_dim = ifd.val.l;
                    break;
			        }			  
              break;
           case 0x101 :  switch (ifd.typ.u)
           {  case 3 : xy_fread16( &ifd.val.u[0], ifd_offset + 8 + i * sizeof(TIF_IFD), f);
                    h->y_dim = ifd.val.u[0];
                    break;
              case 4 : xy_fread32( &ifd.val.l, ifd_offset + 8 + i * sizeof(TIF_IFD), f);
                    h->y_dim = ifd.val.l;
                    break;
			     }			  
             break;
           case 0x102 :  switch (ifd.typ.u)
           {  case 3 : xy_fread16( &ifd.val.u[0], ifd_offset + 8 + i * sizeof(TIF_IFD), f);
                    bitspersample = ifd.val.u[0];
                    break;
              case 4 : xy_fread32( &ifd.val.l, ifd_offset + 8 + i * sizeof(TIF_IFD), f);
                    bitspersample = ifd.val.l;
                    break;
			     }			  
              break;
          case 0x111 :  switch (ifd.typ.u)
           {  case 3 : xy_fread16( &ifd.val.u[0], ifd_offset + 8 + i * sizeof(TIF_IFD), f);
                    stripoffset = ifd.val.u[0];
                    break;
              case 4 : xy_fread32( &ifd.val.l, ifd_offset + 8 + i * sizeof(TIF_IFD), f);
                    stripoffset = ifd.val.l;
                    break;
			     }			  
             break;
          }
        }
    if ( bitspersample == 16) h->t_data = T_INT16U;
    else  if ( bitspersample == 8) h->t_data = T_CHAR;
    else h->t_data = INVALID_DATA;
    h->frames =1;
    h->header_end = stripoffset;
    return h;    
    }
/*-----------------------------------------------------------*/
#define BUF_LG 127
void gel_hdrfill( FILE *f, XY_HDR *h )
{   INT32   num, deno;
    char *c, buffer[BUF_LG+1];
    int i;
    INT16U tag_used;
    INT32  offset;
    long  ifd_offset;
    TIF_IFD ifd;

    h->edf_disp = h->edf_used=0;
    xy_edfstr( h, "HeaderID", "EH:000001:000000:000000");
    xy_edfstr( h, "ByteOrder", "LowByteFirst");
    sprintf(buffer,"%hd", h->x_dim);
    xy_edfstr(h, "Dim_1", buffer);
    sprintf(buffer,"%hd", h->y_dim);
    xy_edfstr(h, "Dim_2", buffer);
    sprintf(buffer,"%d", h->frames);
    xy_edfstr(h, "Image", buffer);
    
    xy_fread32( &offset,  0x04L, f);
    xy_fread16( &tag_used,  offset, f);
    if (tag_used == 0 ) V_ERROR(" no tags found in the file");
    if (tag_used > 100) V_ERROR(" more than 100 tags found in the file");
    ifd_offset = 2 + offset;
    if (tag_used == 0) V_ERROR(" no tags in the file");
/*    printf(" tag_used %04x offset %04x ifd_offset %08x\n", tag_used, offset, ifd_offset);*/
    for (i = 0; i < tag_used; i++)
    {   xy_fread16( &ifd.tag.u, ifd_offset + i * sizeof(TIF_IFD), f);
        xy_fread16( &ifd.typ.u, ifd_offset + 2 + i * sizeof(TIF_IFD), f);
        xy_fread32( &ifd.cnt.l, ifd_offset + 4 + i * sizeof(TIF_IFD), f);
/*        xy_fread32( &ifd.val.l, ifd_offset + 8 + i * sizeof(TIF_IFD), f);*/
        switch (ifd.typ.u)
        {  case 2 : xy_fread32( &ifd.val.l, ifd_offset + 8 + i * sizeof(TIF_IFD), f);
                    fseek(f, ifd.val.l, 0 );
                    fread( buffer, 1, ifd.cnt.l, f);
                    break;
           case 3 : xy_fread16( &ifd.val.u[0], ifd_offset + 8 + i * sizeof(TIF_IFD), f);
                    sprintf(buffer,"%hd", ifd.val.u[0] );
                    break;
           case 4 : xy_fread32( &ifd.val.l, ifd_offset + 8 + i * sizeof(TIF_IFD), f);
                    sprintf(buffer,"%d", ifd.val.l );
                    break;
           case 5 : xy_fread32( &ifd.val.l, ifd_offset + 8 + i * sizeof(TIF_IFD), f);
                    xy_fread32( &num, ifd.val.l, f);
                    xy_fread32( &deno, ifd.val.l + 4, f);
                    sprintf(buffer,"%ld / %ld", num, deno);
                    break;
           default : buffer[0]=0;
                    }         
        print_ifd(i, tag_used, &ifd, buffer);
        xy_edfstr(h, ifd_tag_name(ifd.tag.u), buffer);
        }
    sprintf(buffer, "%s based on tiff#6, %s", __FILE__, __DATE__);
    c = strrchr( buffer, '\n');
    if ( c ) *c=0;
    c = strrchr( buffer, '\r');
    if ( c ) *c=0;
    xy_edfstr(h, "Software", buffer);
    if (h->t_data != T_INT16U && h->t_data != T_CHAR )
    {    xy_fputhdr(stderr, h, 1);
         V_ERROR(" not supported data type!\n");
         }
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
XY_HDR  *gel_open (char * name, char *msg, int quick)
{   FILE   *f;
    XY_HDR *h;
    char   *n, buffer[200];
    strcpy (buffer, name);
    if ( strstr(buffer, ".gel") == NULL && strstr(buffer, ".tif") == NULL ) strcat(buffer, ".gel");
    f = fopen( buffer, "rb");
    if ( f == NULL ) v_error( __FILE__, "gel_open : unable to open %s file '%s'\n", msg, buffer);
    h = gel_gethdr( f );
    if (h->t_data != T_INT16U || quick == 0 )
    {    gel_hdrfill(f , h);
         }
    n = (char * ) malloc( 1+strlen(buffer));
    strcpy (n, buffer);
    h->name = n;
	 h->xy_mode = GEL_XYMODE;
    h->file = f;
/*    xy_fputhdr(stderr, h, 1); */
    return h;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
static int gel_getraw8 (XY_HDR *h, IMAGE *img, INT16U *val, int pos);
static int gel_getraw16(XY_HDR *h, IMAGE *img, INT16U *val, int pos);
int gel_getraw(XY_HDR *h, IMAGE *img, INT16U *val, int pos)
{    if (h->t_data == T_INT16U) return gel_getraw16 (h, img, val, pos);
     if (h->t_data == T_CHAR) return gel_getraw8 (h, img, val, pos);
     return 0;
     }
/*-----------------------------------------------------------*/
/* recupere une image depuis la position courante du fichier */
static int gel_getraw16(XY_HDR *h, IMAGE *img, INT16U *val, int pos)
{   int  i, j, k, xread, xseek, xfor, yfor;
    long    p;
    INT16U  *v;

   p = h->header_end + sizeof(INT16U) * ( (pos-1) * img->osize
           + img->y_omin * img->x_osize + img->x_omin );
   xread=sizeof(INT16U)*img->x_tsize;
   xseek=sizeof(INT16U)*img->x_osize;
   xfor=img->x_tsize;
   yfor=img->y_tsize;
   for ( k=0, v=val; k<yfor; k++, v+=xfor, p+=xseek )
   {   fseek( h->file, p, 0);
       if ( (j=fread( v, xread, 1, h->file)) != 1 )
       if ( k == 0 )  return 0;
       else
       {   fprintf(stderr, "gel_getraw16 error %d reading %d image at y = %d, y_min %d, pos %d\n",
                  errno, j, k+img->y_omin, img->y_omin, pos);
           return -1;
           }
       if (xy_doswap) for (i=0; i < xfor; i++) xy_eswap16 (v+i);
       }   
   return img->y_tsize;    
   }
/*-----------------------------------------------------------*/
static int gel_getraw8(XY_HDR *h, IMAGE *img, INT16U *val, int pos)
{   int  i, j, k, xread, xseek, xfor, yfor;
    long    p;
    INT16U  *v;
    unsigned char *t;
   p = h->header_end + ( (pos-1) * img->osize
           + img->y_omin * img->x_osize + img->x_omin );
   xread=img->x_tsize;
   xseek=img->x_osize;
   xfor=img->x_tsize;
   yfor=img->y_tsize;
   t = malloc(xfor);
   for ( k=0, v=val; k<yfor; k++, v+=xfor, p+=xseek )
   {   fseek( h->file, p, 0);
       if ( (j=fread( t, xread, 1, h->file)) != 1 )
       if ( k == 0 )  return 0;
       else
       {   fprintf(stderr, "gel_getraw8 error %d reading %d image at y = %d, y_min %d, pos %d\n",
                  errno, j, k+img->y_omin, img->y_omin, pos);
           free (t);
           return -1;
           }
       for (i=0; i < xfor; i++, t) v[i] = t[i];
       }   
   free (t);
   return img->y_tsize;    
   }
/*-----------------------------------------------------------*/
int gel_getimg(XY_HDR *h, IMAGE *img, int pos)
{   INT16U *raw;
    int i;
    raw = (INT16U *) malloc(img->osize * sizeof(INT16U));
    i = gel_getraw(h, img, raw, pos);
    xy16u_bind( img, raw);
    free(raw);
    img->name = h->name;
    return i;
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
char *ifd_tag_name( INT16U tag)
{   static char name[16];
    switch (tag)
    {  case 0x0FE  : return "NewSubFileType"; 
       case 0x0FF  : return "OldNewSubFileType";
       case 0x100  : return "ImageWidth";
       case 0x101  : return "ImageLength";
       case 0x102  : return "BitsPerSample";
       case 0x103  : return "Compression";
       case 0x106  : return "PhotometricInt.";
       case 0x10d  : return "DocumentName";
       case 0x10e  : return "Description";
       case 0x110  : return "Manufacturer";
       case 0x111  : return "StripOffset";
       case 0x116  : return "RowPerStrip";
       case 0x117  : return "StripByteCounts";
       case 0x118  : return "MinSampleValue";
       case 0x119  : return "MaxSampleValue";
       case 0x11a  : return "XResolution";
       case 0x11b  : return "YResolution";
       case 0x128  : return "ResolutionUnit";
       case 0x131  : return "Software";
       case 0x132  : return "DateTime";
       }
    sprintf(name,"TAG %04x ???", tag);
    return name;
    }
/*-----------------------------------------------------------*/
void print_ifd ( int i, int n, TIF_IFD *ifd, char *b )
{   char *ifd_type, typ_txt[6];
    switch (ifd->typ.u)
    {  case 2  : ifd_type="ASCII"; break;
       case 3  : ifd_type="SHORT"; break;
       case 4  : ifd_type="LONG"; break;
       case 5  : ifd_type="RATIONAL"; break;
       default : sprintf(typ_txt,"%d",ifd->typ.u); ifd_type=typ_txt;
       }
    printf(" %2d/%2d TIF_IFD %04x %16s %8s * %2d = ", i, n, 
    ifd->tag.u, ifd_tag_name(ifd->tag.u), ifd_type, ifd->cnt.l);
    switch (ifd->typ.u)
    {  case 2  : printf("fileoffset %d '%s'\n", ifd->val.l, b); break;
       case 3  : printf("%d\n", ifd->val.u[0]); break;
       case 5  : printf("fileoffset %d '%s'\n", ifd->val.l, b); break;
       default : printf("%d\n", ifd->val.l);
       }
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
int add_short_ifd( TIF_IFD **p_ifd, INT16U tag, INT16U val)
{   (*p_ifd)->tag.u = tag;
    (*p_ifd)->typ.u=3;         /* SHORT */
    (*p_ifd)->cnt.l=1;
    (*p_ifd)->val.u[0] = val;
    (*p_ifd)++;
    return 1;
    }
int add_long_ifd( TIF_IFD **p_ifd, INT16U tag, INT32 val)
{   (*p_ifd)->tag.u = tag;
    (*p_ifd)->typ.u=4;         /* LONG*/
    (*p_ifd)->cnt.l=1;
    (*p_ifd)->val.l = val;
    (*p_ifd)++;
    return 1;
    }
int add_rat_ifd( TIF_IFD **p_ifd, INT16U tag, char** array, int *array_start, INT32 num, INT32 deno)
{   INT32 *p;
    (*p_ifd)->tag.u = tag;
    (*p_ifd)->typ.u=5;         /* RATIONAL = 2 LONG */
    (*p_ifd)->cnt.l=1;
    (*p_ifd)->val.l = *array_start;
    p = (INT32 *) *array;
    *p = num;
    *(p+1) = deno;
    *array_start += 8;
    *array += 8;
    (*p_ifd)++;
    return 1;
    }
int add_asc_ifd( TIF_IFD **p_ifd, INT16U tag, char** array, int *array_start, char*str)
{   (*p_ifd)->tag.u = tag;
    (*p_ifd)->typ.u=4;         /* LONG*/
    (*p_ifd)->cnt.l=1;
/*    (*p_ifd)->val.l = val;
*/    (*p_ifd)++;
    return 1;
    }
/*-----------------------------------------------------------*/
#define TAG_USED 13
#define ARRAY_SIZE 100
void     gel_write  (IMAGE *img, char *suf, int dyn)
{   long i, j;
    char fname[256];
    XY_HDR *h;
    XY_EDF *p;
    FILE *fout;
    TIF_IFD tif_ifd[TAG_USED], *ifd;
    int  tag_used = 0;
    int  array_start=0;
    char *c, *array, array_mem[ARRAY_SIZE];
    INT16U  *u, whdr[5], tif_mode;
    SWAP16  swaptest;
    INT32 *v, maxi, mini, w, orig;
    double scale;
    
    swaptest.brut = 0x7fff;
    strcpy(fname, img->name);
    if (strstr( fname,".gel") == NULL && strstr( fname,".tif") == NULL ) strcat(fname, suf);
    if (strstr( fname,".gel") == NULL && strstr( fname,".tif") == NULL ) strcat(fname, ".gel");
    fout = fopen(fname, "wb");
    h = img->header;
    if ( fout == NULL ) v_error(__FILE__, "unable to open the gel out file : %s\n", fname);
    p = h->edf;
    mini = img->info.mini;
    maxi = img->info.maxi;
    scale = orig = 0;
	 if ( mini < 0 ) orig = mini;
    if ( dyn == 0 )  /* set to 8 bits */
    {  if ( mini > 0 && maxi < 256 ) tif_mode = 8; 
       else if (mini > 0 && maxi <= 0xFFFFL ) tif_mode = 16; 
       else tif_mode = 32;
       }
    else if ( dyn == 1 )  /* set to 16 bits */ 
    {  if ( maxi > 0xFFFFL ) orig = mini;
       scale = 0xFFFFL / (double)(maxi - orig);
       if (scale > 1) scale = 0;
       tif_mode = 16;
       }
    else if ( dyn == 2 )
    {  if ( maxi > 0xFFL ) orig = mini;
       scale = 0xFFL / (double)(maxi - orig);
       if (scale > 1) scale = 0;
       tif_mode = 8;
       }
    else 
    {  if (mini < 0 ) orig = mini; 
       scale = 0xFFFFL / (double)(maxi - orig);
       if (scale > 1) scale = 0;
       tif_mode = 16;
       }
    prg_printf(" writing %s grayscale with %d bits\n", fname, tif_mode, mini);
    if ( orig ) prg_printf(" offset of %d has been used\n", orig);
    if ( scale ) prg_printf(" pixel intensities are multiplied by %lf\n", scale);
    ifd=tif_ifd;
    c = (char*) &w;
    u = (INT16U*) &w;
    memset( whdr, 0, sizeof(whdr));
    if ( (char)swaptest.c.h < 0 )
    {    whdr[0]= 0x4949; /* II : byte order : Intel */
         whdr[2]= 8;      /* IFD offset is a long */
         }
    else
    {    whdr[0]= 0x4d4d; /* MM : byte order : Motorola */
         whdr[3]=8;       /* first IFD offset */
          c += 3;
			 u += 1;
			 }
    whdr[1]=0x2a;
    whdr[4]=TAG_USED;  /* Dir entries in the unique IFD, fields required for grayscale*/
    fwrite( whdr, 1, 10, fout);
    memset( array_mem, 0, ARRAY_SIZE);
    array_start = 0x0A + TAG_USED * sizeof(TIF_IFD) + 4 ;
    array = array_mem;
    memset( tif_ifd, 0, TAG_USED*sizeof(TIF_IFD));
    tag_used += add_short_ifd( &ifd, 0x100, img->x_size); /* ImageWidth */
    tag_used += add_short_ifd( &ifd, 0x101, img->y_size); /* ImageLength */
    tag_used += add_short_ifd( &ifd, 0x102, tif_mode);    /* BitsPerSample */
    tag_used += add_short_ifd( &ifd, 0x103, 1);           /* Compression */
    tag_used += add_short_ifd( &ifd, 0x106, 0);           /* PhotometricInterpretation */
    tag_used += add_short_ifd( &ifd, 0x111, array_start + ARRAY_SIZE);/* StripOffsets */
    tag_used += add_long_ifd( &ifd, 0x116, img->y_size); /* RowPerStrip */
    if ( tif_mode == 8 ) tag_used += add_long_ifd( &ifd, 0x117, img->size);   /* StripByteCounts */
    else if ( tif_mode == 16 )tag_used += add_long_ifd( &ifd, 0x117, img->size*2);
    else tag_used += add_long_ifd( &ifd, 0x117, img->size*4);
    tag_used += add_short_ifd( &ifd, 0x118, 0); /* MinSampleValue */
    tag_used += add_short_ifd( &ifd, 0x119, maxi); /* MaxSampleValue */
    tag_used += add_rat_ifd( &ifd, 0x11a, &array, &array_start, 1, 1); /* XResolution */
    tag_used += add_rat_ifd( &ifd, 0x11b, &array, &array_start, 1, 1); /* YResolution */
    tag_used += add_short_ifd( &ifd, 0x128, 1);           /* ResolutionUnit */
    for (i=0; i<tag_used; i++) print_ifd(i, TAG_USED, tif_ifd+i, "");
    /* now write the file */
    fwrite( tif_ifd, TAG_USED, sizeof(TIF_IFD), fout);      
    memset( whdr, 0, sizeof(whdr));
    fwrite( whdr, 1, 4, fout);             /* Unsused offset for IFD */
    fwrite( array_mem, 1, ARRAY_SIZE, fout);   /* strings... */
    v = img->data;
    for (i=0; i<img->size; i++, v++) 
    {  w = *v - orig;
       if ( scale ) w = ( w * scale );
       if (tif_mode == 8 ) fwrite( c, 1, 1, fout);
       else if (tif_mode == 16 ) fwrite( u, 1, 2, fout);
       else  fwrite(&w, 1, 4, fout); 
		 } 
    fclose (fout);
    }
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/* ------------------------------------------------------- */
/*-----------------------------------------------------------*/

