static char *cvs_id =" $Id: prg_lib.c,v 1.3 2002/07/19 15:12:06 berar Exp $ ";
/*  prg_lib.c  */
#include "prg_def.h"
#include <errno.h>
/*-----------------------------------------------------------*/
#ifdef __WIN32__
#define PATH_CHAR '\\'
#define PATH_STR  "\\"
#else
#define PATH_CHAR '/'
#define PATH_STR  "/"
#endif
/*-----------------------------------------------------------*/
void prg_basename(char *buffer, char *src_name)
{   char *c;
    c = strrchr(src_name, PATH_CHAR);
    if ( !c ) c = src_name; else c++;
    strcpy(buffer, c);
    c=strchr(buffer, '.');
    if ( c ) *c=0;
    }
/*-----------------------------------------------------------*/
void prg_pathname(char *buffer, char *src_name)
{   char *c;
    strcpy( buffer, src_name);
    c = strrchr(buffer, PATH_CHAR);
    if ( !c ) c = buffer; else c++;
    *c=0;
    }
/*-----------------------------------------------------------*/
void prg_extname(char *buffer, char *src_name)
{   char *c;
    strcpy( buffer, src_name);
    c = strchr(src_name, '.');
    if ( c ) strcpy( buffer, c);
    else *buffer = 0;
    }
/*-----------------------------------------------------------*/
void prg_outname(char *buffer, char *name, char *def_name, char *def_ext, char *def_path)
{   char *c, b[200];
    prg_pathname(b, name);
    if (*b == 0 && def_path) strcpy(b, def_path);
    if ( *b )
    {  c = strrchr(b, PATH_CHAR);
       if ( !c || c - b != strlen(b)-1 ) strcat(b, PATH_STR);
       }
    strcpy (buffer, b);
    prg_basename(b, name);
    if (*b == 0 && def_name) prg_basename(b, def_name);
    strcat (buffer, b);
    if (def_ext) strcat(buffer, def_ext);
    }
/*-----------------------------------------------------------*/
char * prg_get_name(char *tag, char * buffer)
{  char *c, *d, *e; 
	c = buffer + strlen(tag);
	while ( *c == ' ' || *c == '=') c++;
	e = c;
	while ( *e && *e != ' ') e++;
	*e=0;
	d = str_alloc(c);
	return d;
	}      
/*-----------------------------------------------------------*/
void prg_inifile( void parameter(FILE *f_ini) )
{   char buffer[200];
    FILE * f_ini;
    prg_basename(buffer, prg_name);
    strcat(buffer, ".ini");
    f_ini = fopen( buffer, "r");
    if ( f_ini != NULL )
    {   printf(" using file '%s'\n", buffer);
        parameter( f_ini);
        fclose (f_ini);
        }
    else printf( " no file '%s' using defaults\n", buffer);
   }
/*-----------------------------------------------------------*/
int prg_initag(char *b, char **tag, char **arg)
{   char *d, *e;
    while (*b == ' ' || *b == '\n' || *b == '\r') b++;
    *tag = *arg = NULL;
	 if (*b=='#' || *b==0) return 0;
    *tag=b;
    if ( (d=strchr(b, '#'))) *d =0;
	 if ( (e=strchr(b, '='))) *e =0;
	 d=b+strlen(b)-1;
    while (*d==' ') d--;
	 *(d+1)=0;
	 if (**tag==0) return 0;
	 d=e+1;
    while (*d==' ') d++;
	 *arg=d;
	 d+=strlen(d)-1;
    while (*d==' ' || *d== '\n' || *d== '\r') d--;
	 *(d+1)=0;
	 return 1;	  
  }   
/*-----------------------------------------------------------*/
int prg_inistr(char *tag, char *arg, char *key, char **s)
{   char *d, *e;
    if ( strcmp(tag, key) != 0 ) return 0;
    *s = malloc(1+strlen(arg));
    strcpy(*s, arg);
    printf(" %10s= '%s'\n", key, *s);
    return 1;
  }   
/*-----------------------------------------------------------*/
int prg_iniint(char *tag, char *arg, char *key, int *d)
{   if ( strcmp(tag, key) != 0 ) return 0;
    sscanf(arg," %d", d);
    printf(" %10s= %d\n", key, *d);
    return 1;
    }   
/*-----------------------------------------------------------*/
int prg_iniflt(char *tag, char *arg, char *key, float *f)
{   if ( strcmp(tag, key) != 0 ) return 0;
    sscanf(arg," %f", f);
    printf(" %10s= %f\n", key, *f);
    return 1;
    }   
/*-----------------------------------------------------------*/
int prg_inidbln(char *tag, char * arg, char *key, double *d, int n)
{   int i, r;
    if ( strcmp(tag, key) != 0 ) return 0;
    if (n<=0) n=1;
    printf(" %10s=", key);
    for (i=0;i<n;i++) 
    {   sscanf(arg," %lf%n", d+i, &r);
        printf(" %lf ", d[i]);
        arg+=r;
        }
    printf("\n");
    return 1;
    }   
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
/*-----------------------------------------------------------*/
char * str_alloc(char * model)
{  char *p;
   p = (char *) malloc(1+strlen(model));
   if (p == NULL) v_error(__FILE__, " : allocating string : '%s' %d\n", model, strlen(model));
   strcpy(p, model);
   return p;
  }
/*-----------------------------------------------------------*/
void *prg_alloc(char *file, char *name, long size, int zeroset)
{  void *p;
   p = (void *)malloc(size);
   if (p == NULL) v_error(__FILE__, " %s : allocating memory : %s %d\n", file, name, size);
   if (zeroset) memset(p, 0, size);
   return p;
   }	      
/*-----------------------------------------------------------*/
void *prg_realloc(char *file, char *name, void *ptr, long size)
{  void *p;
   p = (void *)realloc(ptr, size);
   if (p == NULL) v_error(__FILE__, " %s : reallocating memory : %s %d\n", file, name, size);
   return p;
   }	      
/*-----------------------------------------------------------*/
/* error function : abort with message                       */
/* --------------------------------------------------------- */
#ifdef STDARG
void v_error (char *lib_name, char *format, ... )
{   va_list argptr;

    fprintf (stderr," %s error (errno=%d) : ", lib_name, errno);
    va_start (argptr, format);
    vfprintf (stderr, format, argptr);
    va_end (argptr);
    fprintf (stderr," aborting\n\n");
#ifdef __WIN32__
puts ("\nwaiting keyboard"); getchar();
#endif
    exit(3);
    }
#else
/*  les memes avec varargs............... */
void v_error (va_alist)
va_dcl
{   va_list args;
    char *format;
    fprintf (stderr," %s error (errno=%d) : ", lib_name, errno);
    va_start (args);
    format = va_arg(args, char *);
    vfprintf (stderr,format, args);
    va_end (args);
    exit(3);
    }
#endif
/* ------------------------------------------------------- */
#include <stdarg.h>
int log_mode;
static FILE *log_file;
int prg_printf( char *format, ...)
{  char msg[250];
   int i;
   va_list argptr;
   if (log_mode && log_file == NULL)
   {  strcpy (msg, prg_name);
      strcat (msg, ".log");
      switch (log_mode)
      {  case 1 : log_file = fopen( msg, "w");  break;
         case 2 : log_file = fopen( msg, "a");  break;
         }
      log_mode = 0;
      }
   va_start (argptr, format);
   vsprintf (msg, format, argptr);
   va_end (argptr);
   if (log_file) { fprintf(log_file, "%s", msg);
                   fflush(log_file); }
   i = printf("%s", msg);
   return i;
   }
int prg_fprintf( FILE *f, char *format, ...)
{  char msg[250];
   int i;
   va_list argptr;
   if (log_mode && log_file == NULL)
   {  strcpy (msg, prg_name);
      strcat (msg, ".log");
      switch (log_mode)
      {  case 1 : log_file = fopen( msg, "w");  break;
         case 2 : log_file = fopen( msg, "a");  break;
         }
      log_mode = 0;
      }
   va_start (argptr, format);
   vsprintf (msg,format, argptr);
   va_end (argptr);
   if (log_file) fprintf(log_file, "%s", msg);
   i = fprintf(f, "%s", msg);
   return i;
   }
/*-----------------------------------------------------------*/
int prg_fflush( FILE *f)
{  fflush(f);
   if (log_file) fflush(log_file);
	}
/*-----------------------------------------------------------*/

