static char *cvs_id =" $Id: xy_excl.c,v 1.3 2002/06/20 07:50:46 berar Exp $ ";
/*  bm_stat : image princeton (Winview ) et autres    */
/*  jfberar   berar@esrf.fr */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
/*-----------------------------------------------------------*/
#include "xy_def.h"

ZONE *excluded = NULL;
int  n_excluded = 0;
int  m_excluded = 0;
char *quiet;
/*-----------------------------------------------------------*/
int pixel_off( INT16U x, INT16U y, IMAGE *img, unsigned char mod, INT32 v); 
int pixel_on( INT16U x, INT16U y, IMAGE *img, INT16U * frame); 
int excl_pixel( ZONE *l_excl, IMAGE *img, int print, INT16U * frame);
int excl_circ ( ZONE *l_excl, IMAGE *img, int print, INT16U * frame);
int excl_rect ( ZONE *l_excl, IMAGE *img, int print, INT16U * frame);
int excl_tria ( ZONE *l_excl, IMAGE *img, int print, INT16U * frame);
/*-----------------------------------------------------------*/
void excl_ini(int excl_type, char *line )
{  int i, x, y, r, m, v;
   char *bline;
   ZONE * l_excl;
	char *excl_roi;
	i = n_excluded++;
   if (excluded==NULL ) 
   {  excluded = (ZONE *) malloc( (m_excluded+10) *sizeof(ZONE));
      m_excluded +=10;
      }
   else if (n_excluded > m_excluded ) 
   {  excluded = (ZONE *) realloc(excluded, (m_excluded+10) *sizeof(ZONE));
	   m_excluded +=10;
      }
    l_excl = excluded+i;
	 l_excl->v = 0;
	 l_excl->t = excl_type;
    bline = strchr(line, '=');
    if ( bline ) bline ++;
    else { bline = line; }
	 quiet = strstr(line, "QUIET");
	 excl_roi = (excl_type & ROI ) ? "_ROI" : "_EXCLUDED";
	 switch ( excl_type & ~ ROI )
	 {  case P_EXCL : m = sscanf(bline,"%hd%hd%d", &(l_excl->x1), &(l_excl->y1),
	         &(l_excl->v)); 
	      l_excl->m =  (m==3) ? 1 : 0;
         if (!quiet) printf(" add P%s point x %d y %d", excl_roi, l_excl->x1, l_excl->y1); 
			break;
	    case C_EXCL : m = sscanf(bline,"%hd%hd%hd%d", &l_excl->x1, &l_excl->y1,
	         &l_excl->x2, &l_excl->v); 
	      l_excl->m =  (m==4) ? 1 : 0;
         if (!quiet) printf(" add C%s circle x %d y %d r %d", excl_roi, l_excl->x1, l_excl->y1,
			  l_excl->x2); 
			break;
	    case R_EXCL : m = sscanf(bline,"%hd%hd%hd%hd%d", &l_excl->x1, &l_excl->y1,
	         &l_excl->x2, &l_excl->y2, &l_excl->v); 
	      l_excl->m =  (m==5) ? 1 : 0;
         if (!quiet) printf(" add R%s rectangle x1 %d y1 %d x2 %d y2 %d", excl_roi, l_excl->x1, l_excl->y1,
			  l_excl->x2, l_excl->y2); 
			break;
	    case T_EXCL : m = sscanf(bline,"%hd%hd%hd%hd%hd%hd%d",&l_excl->x1, &l_excl->y1, 
	       &l_excl->x2, &l_excl->y2, &l_excl->x3, &l_excl->y3,
			 &l_excl->v); 
	      l_excl->m =  (m==7) ? 1 : 0;
         if (!quiet) printf(" add T%s triangle x1 %d y1 %d x2 %d y2 %d x3 %d y3 %d", excl_roi, l_excl->x1, l_excl->y1,
			  l_excl->x2, l_excl->y2, l_excl->x3, l_excl->y3); 
			break;
		 }
       if (!quiet)  
		 {  if (l_excl->m ) printf(" (modify to %d)\n", l_excl->v);
		    else printf("\n"); }
       }
/*-----------------------------------------------------------*/
void excl_image ( IMAGE *img, int print)
{  long i, j, ne;
   int roi =0;
	INT32 v = 0;
   ne = 0;
   for (i=0; i < n_excluded; i++) if ( excluded[i].t & ROI ) roi++; 
	if (roi)
	{  INT16U * frame;
	   frame = (INT16U *) prg_alloc("xy_excl", "roi frame buffer", img->size * sizeof(INT16U), 1);
	   memcpy(frame, img->frame, img->size* sizeof(INT16U));
	   memset(img->frame, 0, img->size* sizeof(INT16U));
	   ne = img->size;
		for (i=0; i < n_excluded; i++)
      {  switch ( excluded[i].t )
		   {  case C_EXCL+ROI : ne -= excl_circ (excluded+i, img, print, frame); break;
		      case R_EXCL+ROI : ne -= excl_rect (excluded+i, img, print, frame); break;
		      }
		    }
	   free(frame);		 
		}	 		
   for (i=0; i < n_excluded; i++)
   {  switch ( excluded[i].t )
		{  case P_EXCL : ne += excl_pixel(excluded+i, img, print, NULL); break;
		   case C_EXCL : ne += excl_circ (excluded+i, img, print, NULL); break;
		   case R_EXCL : ne += excl_rect (excluded+i, img, print, NULL); break;
		   case T_EXCL : ne += excl_tria (excluded+i, img, print, NULL); break;
		   }
		}	 
   printf("# %d excluded pixel(s) for calculations\n", ne);
   }
/*-----------------------------------------------------------*/
int pixel_off( INT16U x, INT16U y, IMAGE *img, unsigned char mod, INT32 v)
{  long j;
   if ( x < img->x_omin || x >= img->x_omax ) return 0;
   if ( y < img->y_omin || y >= img->y_omax ) return 0;
   j = (y-img->y_omin)/img->y_obind * img->x_size + (x-img->x_omin)/img->x_obind;
/* printf(" %d %d  m %d v %d  f %d\n", x, y, mod, v, img->frame[j]); */
   if (img->frame[j]==0 ) return 0;
   img->frame[j]=0;
	if (mod) 
	{  if ( v == -1 )
	   {  long jj, vv, nn;
		   nn = vv =0;
			if (x!=0)
			{ jj = (y-img->y_omin)/img->y_obind * img->x_size + (x-1-img->x_omin)/img->x_obind;
           if (img->frame[jj]) { vv+=img->data[jj]; nn++;}
			  }
			if (x!=img->x_size-2)
			{  jj = (y-img->y_omin)/img->y_obind * img->x_size + (x+1-img->x_omin)/img->x_obind;
            if (img->frame[jj]) { vv+=img->data[jj]; nn++;}
				}
			if (y!=0)
			{ jj = (y-1-img->y_omin)/img->y_obind * img->x_size + (x-img->x_omin)/img->x_obind;
           if (img->frame[jj]) { vv+=img->data[jj]; nn++;}
			  }
			if (y!=img->y_size-2)
			{  jj = (y+1-img->y_omin)/img->y_obind * img->x_size + (x-img->x_omin)/img->x_obind;
            if (img->frame[jj]) { vv+=img->data[jj]; nn++;}
				}
		   if (nn) vv/=nn;
			img->data[j] = vv;
			}
	   else img->data[j] = v;
		}
	return 1;
   }
/*-----------------------------------------------------------*/
int pixel_on( INT16U x, INT16U y, IMAGE *img, INT16U *frame)
{  long j;
   if ( x < img->x_omin || x >= img->x_omax ) return 0;
   if ( y < img->y_omin || y >= img->y_omax ) return 0;
   j = (y-img->y_omin)/img->y_obind * img->x_size + (x-img->x_omin)/img->x_obind;
/* printf(" %d %d  m %d v %d  f %d\n", x, y, mod, v, img->frame[j]); */
   if (img->frame[j]!=0 ) return 0;
   img->frame[j]=frame[j];
	return 1;
   }
/*-----------------------------------------------------------*/
int excl_pixel( ZONE *l_excl, IMAGE *img, int print, INT16U *frame)
{  int n = 0;
	char *t = ( frame == NULL) ? "exclud" : " includ";
	if ((print & 32)) printf("# %sing pixel %d %d\n", t, l_excl->x1, l_excl->y1); 
   if (frame == NULL) n += pixel_off ( l_excl->x1, l_excl->y1, img, l_excl->m, l_excl->v);
	else  n += pixel_on ( l_excl->x1, l_excl->y1, img, frame);
   return n;
	}    
/*-----------------------------------------------------------*/
int excl_circ ( ZONE *l_excl, IMAGE *img, int print, INT16U *frame)
{  INT16U rx, ry;
   int ix, iy, ro, r2;
   int n = 0;
	char *t = ( frame == NULL) ? "exclud" : " includ";
	if ((print & 32)) printf("# %sing circle %d %d radius %d ", t, l_excl->x1, l_excl->y1,
	   l_excl->x2); 
   ro = l_excl->x2;
	r2 = ro*ro;
   for ( ix = -ro; ix <= ro; ix++ )
   {  rx = ix + l_excl->x1;
      if ( rx < img->x_omin || rx >= img->x_omax ) continue;
      for ( iy = -ro; iy <= ro; iy++ )
      {  ry = iy + l_excl->y1;
         if ( ry < img->y_omin || ry >= img->y_omax ) continue;
         if ( ix*ix+iy*iy <= r2 )
	        if (frame == NULL) n += pixel_off ( rx, ry, img, l_excl->m, l_excl->v);
			  else  n += pixel_on ( rx, ry, img, frame);
		   }
	  }    
	if ((print & 32)) printf(" : %d pixels %sed\n", n, t);
   return n;
  }
/*-----------------------------------------------------------*/
int excl_rect ( ZONE *l_excl, IMAGE *img, int print, INT16U *frame)
{  INT16U rx, ry;
   int x1, x2, y1, y2;
   int n = 0;
	char *t = ( frame == NULL) ? "exclud" : " includ";
	if ((print & 32)) printf("# %sing rectangle %d %d %d %d ", t, l_excl->x1, l_excl->y1,
	   l_excl->x2, l_excl->y2); 
   x1 =  l_excl->x2 < l_excl->x1 ? l_excl->x2 : l_excl->x1;
   x2 =  l_excl->x2 < l_excl->x1 ? l_excl->x1 : l_excl->x2;
   y1 =  l_excl->y2 < l_excl->y1 ? l_excl->y2 : l_excl->y1;
   y2 =  l_excl->y2 < l_excl->y1 ? l_excl->y1 : l_excl->y2;
   for ( rx = x1; rx <= x2; rx++ )
   for ( ry = y1; ry <= y2; ry++ )
	   if (frame == NULL) n += pixel_off ( rx, ry, img, l_excl->m, l_excl->v);
		else  n += pixel_on ( rx, ry, img, frame);
	if ((print & 32)) printf(" : %d pixels %sed\n", n, t);
   return n;
  }
/*-----------------------------------------------------------*/
int excl_tria ( ZONE *l_excl, IMAGE *img, int print, INT16U *frame)
{  INT16U rx, ry;
   int x1, x2, y1, y2;
	float x12, y12, x13, y13, x23, y23;
	float a12, b12, a13, b13, a23, b23;
   int n = 0;
	char *t = ( frame == NULL) ? "exclud" : " includ";
	if ((print & 32)) printf("# %sing triangle %d %d  %d %d   %d %d ", 
	   t, l_excl->x1, l_excl->y1, l_excl->x2, l_excl->y2, l_excl->x3, l_excl->y3);
   x1 =  l_excl->x2 < l_excl->x1 ? l_excl->x2 : l_excl->x1;
   if (l_excl->x3 < x1 ) x1 = l_excl->x3;
   x2 =  l_excl->x2 < l_excl->x1 ? l_excl->x1 : l_excl->x2;
   if (l_excl->x3 > x2 ) x2 = l_excl->x3;
   y1 =  l_excl->y2 < l_excl->y1 ? l_excl->y2 : l_excl->y1;
   if (l_excl->y3 < y1 ) y1 = l_excl->y3;
   y2 =  l_excl->y2 < l_excl->y1 ? l_excl->y1 : l_excl->y2;
   if (l_excl->y3 > y2 ) y2 = l_excl->y3;
   /* we check only for point inside the rectangle x1 y1, x2 y2 */
	/* float is due to conversion problem arrising on IBM AIX */
	y13 = (float) l_excl->y3 - (float) l_excl->y1;
	y12 = (float) l_excl->y2 - (float) l_excl->y1;
	y23 = (float) l_excl->y3 - (float) l_excl->y2;
	x13 = (float) l_excl->x3 - (float) l_excl->x1;
	x12 = (float) l_excl->x2 - (float) l_excl->x1;
	x23 = (float) l_excl->x3 - (float) l_excl->x2;
	a23 = x12 * y13 - y12 * x13;
	a13 = x12 * y23 - y12 * x23;
	a12 = x13 * y23 - y13 * x23;
/*   printf("\n x %d %d y %d %d  xy %.2f %.2f %.2f  %.2f  %.2f %.2f\n alpha %.2f %.2f %.2f\n",
	 x1, x2, y1, y2, x12,x13, x23, y12, y13, y23, a12, a13, a23);  */
	if (a12) for ( rx = x1; rx <= x2; rx++ )
   for ( ry = y1; ry <= y2; ry++ )
	{  b23 = (x12 *((float) l_excl->y3 - ry)- y12 *((float) l_excl->x3 - rx))/a23;
	   b12 = (-x13 *((float) l_excl->y2 - ry)+ y13 *((float) l_excl->x2 - rx))/a12;
	   b13 = (x23 *((float) l_excl->y1 - ry)- y23 *((float) l_excl->x1 - rx))/a13;
/* 	   printf(" %d %d --> %.2f %.2f %.2f\n", rx, ry, b12, b13, b23);*/
		if (( b12 >= 0 && b12 <= 1) && ( b13 >= 0 && b13 <= 1) &&( b23 >= 0 && b23 <= 1))
		   if (frame == NULL) n += pixel_off(rx, ry, img, l_excl->m, l_excl->v);
			else  n += pixel_on ( rx, ry, img, frame);
			}
	if ((print & 32)) printf(" : %d pixels %sed\n", n,t );
   return n;
  }
/*-----------------------------------------------------------*/
