static char *cvs_id =" $Id: xy_grid.c,v 1.4 2002/08/22 08:58:06 berar Exp $ ";
/*-----------------------------------------------------------*/
/* grid correction xy_grid.c                                   */
/*-----------------------------------------------------------*/
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
/*-----------------------------------------------------------*/

#include "xy_def.h"
/*typedef struct {  int alloc, size;  double *xcor, *ycor; }  extern GRID_COR grid;*/
/* being here is initialized by defect */
GRID_COR grid_cor = {0,0,NULL,NULL};
static char * grid_mode = NULL;
/*-----------------------------------------------------------*/
int  grid_ini ( GRID_COR *grid, char * tag, char * arg)
{  int n;
   if ( prg_iniint(tag, arg, "GRID_DCOR", &n)) 
   {  grid_struct_ini ( grid, n); 
      return 1;
      } 
   if ( grid->xcor && prg_inidbln(tag, arg, "GRID_XCOR", grid->xcor, grid->size)) return 1;
   if ( grid->ycor && prg_inidbln(tag, arg, "GRID_YCOR", grid->ycor, grid->size)) return 1;
   if ( prg_inistr(tag, arg, "GRID_MODE", & grid_mode)) return 1;
/*   if ( !grid->xcor && strcmp(tag, "GRID_XCOR")) v_error(__FILE__,"GRID_DCOR is required before GRID_XCOR");
   if ( !grid->ycor && strcmp(tag, "GRID_YCOR")) v_error(__FILE__,"GRID_DCOR is required before GRID_YCOR");
*/   return 0;
   }
/*-----------------------------------------------------------*/
void  grid_struct_ini ( GRID_COR *grid, int size)
{   grid->alloc=grid->size=size;
    if (grid->xcor) free (grid->xcor);
    if (grid->ycor) free (grid->ycor);
    grid->xcor = (double *) prg_alloc (__FILE__, "xcor",grid->size*sizeof(double),1);
    grid->ycor = (double *) prg_alloc (__FILE__, "ycor",grid->size*sizeof(double),1);
    } 
/*-----------------------------------------------------------*/
void  grid_struct_def ( GRID_COR *grid, int size, int xo, int yo)
{   grid_struct_ini ( grid, size);
    grid->xcor[1]=1;
    grid->ycor[2]=1;
    grid->xcor[0]=xo;
    grid->ycor[0]=yo;
    grid->size=3;
    } 
/*-----------------------------------------------------------*/
void grid_cor_img ( GRID_COR *grid, IMAGE *img, int scale )
{  float  *surface;
   double *value;
   long sx,sy,sj;
   long tx,ty,tj;
   double x,y,v,s,xo,yo;
   INT32 *i_value;
   INT16U *frame;
   printf ("\n#%s:grid_cor_img  name %s  size %d=%dx%d\n", __FILE__, img->name, img->size,img->x_size,img->y_size);
   
   surface = (float *) prg_alloc(__FILE__, "surface", img->size * sizeof(float), 1);
   value = (double *) prg_alloc(__FILE__, "corrected values", img->size * sizeof(double), 1);
   i_value = img->data;
   frame = img->frame;
   if ( ! i_value) v_error(__FILE__, "no data in %s", img->name);
   for (sy=0; sy<img->y_size; sy++)
   {  yo=sy-grid->ycor[0];
      for (sx=0,sj=sy*img->x_size; sx<img->x_size; sx++,sj++)
      {  xo=sx-grid->xcor[0];
         if (frame && frame[sj]==0) continue;
         tx=x=grid_cor_pos(xo, yo, grid->xcor, grid->size);
         ty=y=grid_cor_pos(xo, yo, grid->ycor, grid->size);
         if(tx>0 && tx<img->x_size && ty>0 && ty<img->y_size) 
         {  tj = ty*img->x_size+tx;
            s = (tx+1-x) * (ty+1-y);
            surface[tj] += s;
            value[tj] += s * i_value[sj];
            }
         tx++;
         if(tx>0 && tx<img->x_size && ty>0 && ty<img->y_size) 
         {  tj = ty*img->x_size+tx;
            s = (tx-x) * (ty+1-y);
            surface[tj] += s;
            value[tj] += s * i_value[sj];
            }
         ty++;
         if(tx>0 && tx<img->x_size && ty>0 && ty<img->y_size) 
         {  tj = ty*img->x_size+tx;
            s = (tx+1-x) * (ty-y);
            surface[tj] += s;
            value[tj] += s * i_value[sj];
            }
         tx--;
         if(tx>0 && tx<img->x_size && ty>0 && ty<img->y_size) 
         {  tj = ty*img->x_size+tx;
            s = (tx+1-x) * (ty-y);
            surface[tj] += s;
            value[tj] += s * i_value[sj];
            }
         }
      }   
   if ( grid_mode && strcmp(grid_mode,"FLUX")==0 )
   { for (sj=0; sj<img->size; sj++) 
       if (surface[sj]) i_value[sj]=value[sj]+0.5;
       else i_value[sj] = 0;
     if (frame) for (sj=0; sj<img->size; sj++) 
          frame[sj] = (surface[sj]) ? 1 : 0;
     }
   else
   { for (sj=0; sj<img->size; sj++) 
       if (surface[sj]) i_value[sj]=0.5+value[sj]/surface[sj];
       else i_value[sj] = 0;
     if (frame) for (sj=0; sj<img->size; sj++) 
          frame[sj] = (surface[sj]) ? 1 : 0;
     }
   free(value);
   free(surface);
   }
/*-----------------------------------------------------------*/
double grid_cor_pos(double x, double y, double *cor, int size)
{  double res;
   int j;
   res = 0;
   for (j=0; j<size;j++) res+= cor[j]*grid_cor_der(j, x, y, cor);
   return res;
   }
/*-----------------------------------------------------------*/
double grid_cor_der(int i, double x, double y, double *cor)
{  switch (i)
   { case 0 : return 1;
     case 1 : return x;
     case 2 : return y;
     case 3 : return x*x;
     case 4 : return x*y;
     case 5 : return y*y;
     case 6 : return x*x*x;
     case 7 : return x*x*y;
     case 8 : return x*y*y;
     case 9 : return y*y*y;
     case 10 : return x*x*x*x;
     case 11 : return x*x*x*y;
     case 12 : return x*x*y*y;
     case 13 : return x*y*y*y;
     case 14 : return y*y*y*y;
     case 15 : return x*x*x*x;
     case 16 : return x*x*x*x*y;
     case 17 : return x*x*x*y*y;
     case 18 : return x*y*y*y;
     case 19 : return x*y*y*y*y;
     case 20 : return y*y*y*y*y;
   }
   return 0;
   }
/*-----------------------------------------------------------*/
